Page MenuHomePhabricator

edje/optimization: keep a readonly flag on edje_style.
ClosedPublic

Authored by smohanty on Aug 11 2019, 8:16 PM.

Details

Summary

Just to check if the edje style has text_class tag we do
lot of pointer hopping by linearly scan through the tags in the
style which is not very cache efficient.

by keeping a readonly flag we can avoid those acess if the style dosen't
have any text_class tags. and if we have those tags then we can start
updating the style straight away.

Diff Detail

Repository
rEFL core/efl
Lint
Automatic diff as part of commit; lint not applicable.
Unit
Automatic diff as part of commit; unit tests not applicable.
smohanty created this revision.Aug 11 2019, 8:16 PM

It seems that this patch has no reviewers specified. If you are unsure who can review your patch, please check this wiki page and see if anyone can be added: https://phab.enlightenment.org/w/maintainers_reviewers/

smohanty requested review of this revision.Aug 11 2019, 8:16 PM

and it doesn't have any memory overhead on _Edje_Style object as it has at least 3 unused byte (padding on 32bit system)

cedric requested changes to this revision.Aug 12 2019, 9:13 AM
cedric added inline comments.
src/lib/edje/edje_private.h
635

To avoid starting ballooning the size of this structure, could you switch both Eina_Bool to Eina_Bool : 1? I know it won't impact the current style structure size, but it will give a better trend for the future.

This revision now requires changes to proceed.Aug 12 2019, 9:13 AM
smohanty updated this revision to Diff 24048.Aug 12 2019, 8:11 PM

used bitfield

smohanty marked an inline comment as done.Aug 12 2019, 8:12 PM
cedric accepted this revision.Aug 14 2019, 11:16 AM
This revision is now accepted and ready to land.Aug 14 2019, 11:16 AM
Closed by commit rEFLd672d55107ef: edje/optimization: keep a readonly flag on edje_style. (authored by subhransu mohanty <sub.mohanty@samsung.com>, committed by cedric). · Explain WhyAug 14 2019, 12:10 PM
This revision was automatically updated to reflect the committed changes.